/* 双方向リスト */
#ifndef MLIST_HEADER
#define MLIST_HEADER

typedef struct _mNode{
  struct _mNode *prev;	/* descの場合last */
  struct _mNode *next;	/* descの場合first */
  void *data;	/* descの場合count */
}mNode,*pMNode;

typedef struct _mNode mDesc;
typedef struct _mNode *pMDesc;

void mListInit(pMDesc list);
int mListCount(pMDesc list);
void mListAdd(pMDesc list,pMNode node);
void mListAddFirst(pMDesc list,pMNode node);
pMNode mListGet(pMDesc list);
pMNode mListDelete(pMDesc list,pMNode delNode);
pMNode mListNext(pMNode node);
pMNode mListPrev(pMNode node);
pMNode mListFirst(pMDesc list);
pMNode mListLast(pMDesc list);
#ifdef DEBUG
void mListShow(pMDesc list);
#endif

#endif
