#include <windows.h>
#include <stdio.h>
#include "grad.h"
#include "mandelcommon.h"

int keyGetStatus(float *x,float *y){
  int numKey;
  int event;
  int ret = -1;

  GWselvp(MAIN_VPORT);
  event = GWevent(x,y);
  if(event > 0){
    if(event >= 0x31 && event <= 0x39){
      numKey = event - 0x30;
      ret = gradSelectGradationNumber(numKey - 1);    
    }else if(event >= VK_NUMPAD1 && event <=VK_NUMPAD9){
      numKey = event - VK_NUMPAD0;
      ret = gradSelectGradationNumber(numKey - 1);
    }
  }else if(event == -1){
    if(*x < PIXEL_X && *x > 0 && *y > 0 && *y < PIXEL_X){
      ret = 1;
    }
    if(*x > DRAW_RECT_PIXEL + DRAW_RECT_MARGIN32 + DRAW_RECT_INNER_MARGIN8 + DRAW_RECT_INNER_MARGIN2 && 
       *x < DRAW_RECT_PIXEL + DRAW_RECT_MARGIN32 + DRAW_RECT_INNER_MARGIN8 + DRAW_RECT_INNER_MARGIN2 * 2 + DRAW_RECT_SUB_PIXEL){
      ret = 3;
      if(*y > - DRAW_RECT_INNER_MARGIN8 + DRAW_RECT_INNER_MARGIN2 && *y < DRAW_RECT_SUB_PIXEL - DRAW_RECT_INNER_MARGIN8 + DRAW_RECT_INNER_MARGIN2){
	*((int *)y) = 1;
      }else if(*y > DRAW_RECT_SUB_PIXEL - DRAW_RECT_INNER_MARGIN8 + DRAW_RECT_INNER_MARGIN2 * 3 && *y < DRAW_RECT_SUB_PIXEL * 2 - DRAW_RECT_INNER_MARGIN8 + DRAW_RECT_INNER_MARGIN2 * 3){
	*((int *)y) = 2;
      }else if(*y > DRAW_RECT_SUB_PIXEL * 2 - DRAW_RECT_INNER_MARGIN8 + DRAW_RECT_INNER_MARGIN2 * 5 && *y < DRAW_RECT_SUB_PIXEL * 3 - DRAW_RECT_INNER_MARGIN8 + DRAW_RECT_INNER_MARGIN2 * 5){
	*((int *)y) = 3;
      }else if(*y > DRAW_RECT_SUB_PIXEL * 3 - DRAW_RECT_INNER_MARGIN8 + DRAW_RECT_INNER_MARGIN2 * 7 && *y < DRAW_RECT_SUB_PIXEL * 4 - DRAW_RECT_INNER_MARGIN8 + DRAW_RECT_INNER_MARGIN2 * 7){
	*((int *)y) = 4;
      }
    }
    if(*x > DRAW_RECT_PIXEL + DRAW_RECT_MARGIN32 * 2 + DRAW_RECT_INNER_MARGIN8 + DRAW_RECT_INNER_MARGIN2 *2 + DRAW_RECT_SUB_PIXEL &&
       *x < DRAW_RECT_PIXEL + DRAW_RECT_MARGIN32 * 2 + DRAW_RECT_INNER_MARGIN8 + DRAW_RECT_INNER_MARGIN2 *2 + DRAW_RECT_SUB_PIXEL + DRAW_RECT_GRAD_BAR_SHIFT - DRAW_RECT_MARGIN16 ){
      ret = 4;
      if(*y < WINDOW_HEIGHT - DRAW_RECT_MARGIN16 - DRAW_RECT_MARGIN32 - DRAW_RECT_INNER_MARGIN8 &&
	 *y > WINDOW_HEIGHT - DRAW_RECT_MARGIN16 - DRAW_RECT_MARGIN32 - DRAW_RECT_INNER_MARGIN8 - FONT_HEIGHT_STATUS){
	*((int *)y) = 1;
	goto END_KEY;
      }
      if(*y < WINDOW_HEIGHT - DRAW_RECT_MARGIN16 - DRAW_RECT_MARGIN32 - DRAW_RECT_INNER_MARGIN8 - FONT_HEIGHT_STATUS&&
	 *y > WINDOW_HEIGHT - DRAW_RECT_MARGIN16 - DRAW_RECT_MARGIN32 - DRAW_RECT_INNER_MARGIN8 - FONT_HEIGHT_STATUS * 2){
	*((int *)y) = 2;
	goto END_KEY;
      }
      if(*y < WINDOW_HEIGHT - DRAW_RECT_MARGIN16 - DRAW_RECT_MARGIN32 - DRAW_RECT_INNER_MARGIN8 - FONT_HEIGHT_STATUS * 2&&
	 *y > WINDOW_HEIGHT - DRAW_RECT_MARGIN16 - DRAW_RECT_MARGIN32 - DRAW_RECT_INNER_MARGIN8 - FONT_HEIGHT_STATUS * 3){
	*((int *)y) = 3;
	goto END_KEY;
      }
      if(*y < WINDOW_HEIGHT - DRAW_RECT_MARGIN16 - DRAW_RECT_MARGIN32 - DRAW_RECT_INNER_MARGIN8 - FONT_HEIGHT_STATUS * 4&&
	 *y > WINDOW_HEIGHT - DRAW_RECT_MARGIN16 - DRAW_RECT_MARGIN32 - DRAW_RECT_INNER_MARGIN8 - FONT_HEIGHT_STATUS * 5){
	*((int *)y) = 5;
	goto END_KEY;
      }
      if(*y < WINDOW_HEIGHT - DRAW_RECT_MARGIN16 - DRAW_RECT_MARGIN32 - DRAW_RECT_INNER_MARGIN8 - FONT_HEIGHT_STATUS * 5&&
	 *y > WINDOW_HEIGHT - DRAW_RECT_MARGIN16 - DRAW_RECT_MARGIN32 - DRAW_RECT_INNER_MARGIN8 - FONT_HEIGHT_STATUS * 6){
	*((int *)y) = 6;
	goto END_KEY;
      }
    }
    if(*x > DRAW_RECT_PIXEL + DRAW_RECT_MARGIN32 * 2 + DRAW_RECT_INNER_MARGIN8 + DRAW_RECT_INNER_MARGIN2 *2 + DRAW_RECT_SUB_PIXEL + SAVE_BMP_RSHIFT &&
       *x < DRAW_RECT_PIXEL + DRAW_RECT_MARGIN32 * 2 + DRAW_RECT_INNER_MARGIN8 + DRAW_RECT_INNER_MARGIN2 *2 + DRAW_RECT_SUB_PIXEL + SAVE_BMP_RSHIFT + DRAW_RECT_BAR_WIDTH -SAVE_BMP_RSHIFT){
      if(*y + DRAW_RECT_INNER_MARGIN8 > 0 && *y + DRAW_RECT_INNER_MARGIN8 < COMMAND_RECT_HEIGHT){
	ret = 5;
	*((int *)y) = 0;
	goto END_KEY;
      }
      if(*y + DRAW_RECT_INNER_MARGIN8 > (COMMAND_RECT_HEIGHT + MARGIN_COMMAND)*1+COMMAND_END_MARGIN && *y + DRAW_RECT_INNER_MARGIN8 < (COMMAND_RECT_HEIGHT + MARGIN_COMMAND)*1+COMMAND_RECT_HEIGHT+COMMAND_END_MARGIN){
	ret = 5;
	*((int *)y) = 1;
	goto END_KEY;
      }
      if(*y + DRAW_RECT_INNER_MARGIN8 > (COMMAND_RECT_HEIGHT + MARGIN_COMMAND)*2+COMMAND_END_MARGIN && *y + DRAW_RECT_INNER_MARGIN8 < (COMMAND_RECT_HEIGHT + MARGIN_COMMAND)*2+COMMAND_RECT_HEIGHT+COMMAND_END_MARGIN){
	ret = 5;
	*((int *)y) = 2;
	goto END_KEY;
      }
      if(*y + DRAW_RECT_INNER_MARGIN8 > (COMMAND_RECT_HEIGHT + MARGIN_COMMAND)*3+COMMAND_END_MARGIN && *y + DRAW_RECT_INNER_MARGIN8 < (COMMAND_RECT_HEIGHT + MARGIN_COMMAND)*3+COMMAND_RECT_HEIGHT+COMMAND_END_MARGIN){
	ret = 5;
	*((int *)y) = 3;
	goto END_KEY;
      }
    }
  }else if(event == -2){
    ret = 2;
  }
  
 END_KEY:
  return ret;
}

/*************************************
-1 何もしない
0 色が変更
1 有効な領域で
2 右クリック
3 サブピクセルでクリック
4 statusエリアでクリック
5 commandエリアでクリック
*************************************/
