#include "mList.h"
#include "mandel.h"

#ifndef THREAD_HEADER
#define THREAD_HEADER

typedef struct _calcTask{
#ifdef __float128
  __float128 x;
  __float128 y;
  __float128 delta;
#else
  double x;
  double y;
  double delta;
#endif
  int line;
  int *brot;
  int iterate;
  pReport pRep;
}calcTask,*pCalcTask;

int threadGetLogicalProcessorNum(void);
int threadInit(int threadNum,pMDesc taskQ);
int startThread(int threadNum);
HANDLE threadCreateMutex(void);
void threadCloseHandle(HANDLE mutexHandle);
HANDLE threadCreateSemaphore(int maxResource);

#endif
